#! /bin/bash

################################################
#
#       TPCS Hosting Service v0.3 (FINAL)
#
#  This the initial set up script. Before
#  You run this file please read the "HOW_TO"
#  file! 
#
###############################################
 
###  Only run this file as root
if [ $UID -ne "0" ] ; then
	echo "NOTICE: you must be root to run this script!" ; echo ; exit 0
fi

### Uncomment if you want to clear screen
#clear

echo "creating the necessary directories..."
### Make necessary directories
mkdir /etc/banner
mkdir /etc/mkaccnt

### Move script files to /usr/local/bin
echo "copying script files to /usr/local/bin..."
cp mkaccnt /usr/local/bin/mkaccnt
cp sql.mo /usr/local/bin/sql.mo

### move welcome banner
echo "setting up tpcs banner..."
cp banner.txt /etc/banner/banner.txt

### create program user files
echo "creating program data files..."
touch /etc/mkaccnt/usr.log
touch /etc/mkaccnt/raw_data.log

### Set appropriate permissions : ONLY root can read/write/execute main scripts!
echo "setting appropriate permissions..."
chmod 700 /usr/local/bin/mkaccnt
chmod 700 /usr/local/bin/sql.mo
chmod 644 /etc/banner/banner.txt

### Set up the banner in /etc/ssh/sshd_config
echo "configuring /etc/ssh/sshd_config..."
echo "Banner /etc/banner/banner.txt" >> /etc/ssh/sshd_config

### add pre-exisintg user names to usr.log file to prevent new users from trying to use them!
echo "adding existing usernames to usr.log..."
for i in `cat /etc/passwd | cut -d : -f 1` ; do echo $i >> /etc/mkaccnt/usr.log ; done

### create the tpcs user and group and set password to "password"
echo "creating group called tpcs..."
groupadd tpcs
echo "creating user account called tpcs..."
useradd -G tpcs -g tpcs -s /bin/bash -c "tpcs_setup" tpcs
echo "setting password for user tpcs..."
echo "password" | passwd --stdin tpcs >> /dev/null

###  Allow user "tpcs" to (only) run the mkaccnt program with root privileges
echo "giving tpcs permission to run mkaccnt as root..."
echo "tpcs ALL=/usr/local/bin/mkaccnt" >> /etc/sudoers

###  Set up alias for sudo command ran by tpcs users
echo "alias mkaccnt='sudo /usr/local/bin/mkaccnt'" >> /home/tpcs/.bashrc

### Lock tpcs' .bashrc file so other users dont add alias commands
chown root:root /home/tpcs/.bashrc
chmod 444 /home/tpcs/.bashrc

### Restart sshd deamon so banner shows up!
echo "restarting sshd daemon..."
/sbin/service sshd restart >> /dev/null

### set up is complete!
echo "Set up is complete! Your TPCS Hosting Service is ready for users now!"
exit
